class COLOR_TAG
inherit TAG
creation make_color
feature
    make_color(c : CHARACTER; b : BOOLEAN) is
    require
	("rgbcmykw").has(c)
    do
	!!name.make(1)
	name.add_last(c)
	color := c
	make(b)
    end

    color : CHARACTER
    name : STRING

    execute(c : CONTEXT) is
    do
	c.put_color(color)
    end

    is_redundant(c : CONTEXT) : BOOLEAN is
    do
	Result := c.color = color
    end
end
