class NOISE
    --generate random data for testing
creation make
feature
    tag_names : ARRAY[STRING]
    tag_count : INTEGER

    init_tag_names is
    do
	!!tag_names.make(1, 100)
	add_tag("B")
	add_tag("I")
	add_tag("S")
	add_tag("EM")
	add_tag("TT")
	add_tag("U")
	add_tag("PL")
	add_tag("r")
	add_tag("g")
	add_tag("b")
	add_tag("c")
	add_tag("m")
	add_tag("y")
	add_tag("k")
	add_tag("w")
	add_tag("0")
	add_tag("0")
	add_tag("1")
	add_tag("2")
	add_tag("3")
	add_tag("4")
	add_tag("5")
	add_tag("6")
	add_tag("7")
	add_tag("8")
	add_tag("9")
    end

    add_tag(s : STRING) is
    do
	tag_count := tag_count + 1
	tag_names.put(s, tag_count)
    end

    tag_stack : LINKED_LIST[INTEGER]

    make is
    local
	i : INTEGER
	length : INTEGER
	tag_p : DOUBLE
	cs_p : DOUBLE
	space_p : DOUBLE
	r : STD_RAND
	seed : INTEGER
    do
	if argument_count < 2 then
	    seed := 0
	else
	    seed := argument(2).to_integer
	end
	if argument_count < 1 then
	    length := 500
	else
	    length := argument(1).to_integer
	end
	init_tag_names
	!!tag_stack.make
	!!r.with_seed(seed)
	tag_p := 0.8
	cs_p := 0.2

	space_p := 0.3
	from i := 1
	until i > length
	loop
	    r.next
	    if r.last_real < tag_p then
		r.next
		if r.last_real < 0.5 then
		    r.next
		    if r.last_real < cs_p then
			open_tag(r.last_integer(tag_count - 7) + 7)
		    else
			open_tag(r.last_integer(7))
		    end
		else
		    close_tag
		end
	    else
		r.next
		if r.last_real < space_p then
		    r.next
		    --io.put_character((" %N%T").item(r.last_integer(4)))
		    io.put_character(' ')
		else
		    r.next
		    io.put_character((64 + r.last_integer(26)).to_character)
		end
	    end
	    if i % 40 = 0 then
		io.put_new_line
	    end
	    i := i + 1
	end

	from
	until tag_stack.is_empty
	loop
	    close_tag
	end
    end

    open_tag(i : INTEGER) is
    do
	io.put_string("<")
	io.put_string(tag_names.item(i))
	io.put_string(">")
	tag_stack.add_last(i)
    end

    close_tag is
    do
	if not tag_stack.is_empty then
	    io.put_string("</")
	    io.put_string(tag_names.item(tag_stack.last))
	    io.put_string(">")
	    tag_stack.remove_last
	end
    end
end
