class SIZE_TAG
inherit TAG
creation make_size
feature
    make_size(i : INTEGER; b : BOOLEAN) is
    require
	0 <= i and i <= 9
    do
	name := i.to_string
	size := i
	make(b)
    end

    size : INTEGER
    name : STRING

    execute(c : CONTEXT) is
    do
	c.put_size(size)
    end

    is_redundant(c : CONTEXT) : BOOLEAN is
    do
	Result := c.size = size
    end
end
