deferred class TAG_SINGLETON
feature
    tag_table : DICTIONARY[TAG, STRING] is
    once
	!!Result.make
    end

    opposite_tag(t : TAG) : TAG is
    do
	if t.tag_start then
	    Result := tag_table.at("/" + t.name)
	else
	    Result := tag_table.at(t.name)
	end
    end

    init_tag_table is
    local
	i : INTEGER
	t : TAG
	it : ITERATOR[CHARACTER]
    do
	--yuk
	!B_TAG!t.make(True)
	!B_TAG!t.make(False)
	!I_TAG!t.make(True)
	!I_TAG!t.make(False)
	!TT_TAG!t.make(True)
	!TT_TAG!t.make(False)
	!U_TAG!t.make(True)
	!U_TAG!t.make(False)
	!S_TAG!t.make(True)
	!S_TAG!t.make(False)
	!EM_TAG!t.make(True)
	!EM_TAG!t.make(False)
	!PL_TAG!t.make(True)
	!PL_TAG!t.make(False)
	from i := 0
	until i > 9
	loop
	    !SIZE_TAG!t.make_size(i, True)
	    !SIZE_TAG!t.make_size(i, False)
	    i := i + 1
	end

	it := ("rgbcmykw").get_new_iterator
	from it.start
	until it.is_off
	loop
	    !COLOR_TAG!t.make_color(it.item, True)
	    !COLOR_TAG!t.make_color(it.item, False)
	    it.next
	end
    end

    b_tag : TAG is
    once
	Result := tag_table.at("B")
    end

    slashb_tag : TAG is
    once
	Result := tag_table.at("/B")
    end

    s_tag : TAG is
    once
	Result := tag_table.at("S")
    end

    slashs_tag : TAG is
    once
	Result := tag_table.at("/S")
    end

    i_tag : TAG is
    once
	Result := tag_table.at("I")
    end

    slashi_tag : TAG is
    once
	Result := tag_table.at("/I")
    end

    u_tag : TAG is
    once
	Result := tag_table.at("U")
    end

    slashu_tag : TAG is
    once
	Result := tag_table.at("/U")
    end

    tt_tag : TAG is
    once
	Result := tag_table.at("TT")
    end

    slashtt_tag : TAG is
    once
	Result := tag_table.at("/TT")
    end

    pl_tag : TAG is
    once
	Result := tag_table.at("PL")
    end

    slashpl_tag : TAG is
    once
	Result := tag_table.at("/PL")
    end

    em_tag : TAG is
    once
	Result := tag_table.at("EM")
    end

    slashem_tag : TAG is
    once
	Result := tag_table.at("/EM")
    end

end
